/******************************************************************************
	SQL972 20/06/2006
	PS_FOREIGN_KEYS ==> supression puis cration de toutes les cls trangres
********************************************************************************/



IF OBJECT_ID('dbo.PS_FOREIGN_KEYS') IS NOT NULL
BEGIN
    DROP PROCEDURE dbo.PS_FOREIGN_KEYS
    IF OBJECT_ID('dbo.PS_FOREIGN_KEYS') IS NOT NULL
        PRINT '<<< FAILED DROPPING PROCEDURE dbo.PS_FOREIGN_KEYS >>>'
    ELSE
        PRINT '<<< DROPPED PROCEDURE dbo.PS_FOREIGN_KEYS >>>'
END
go

CREATE PROCEDURE dbo.PS_FOREIGN_KEYS  

AS  
 
BEGIN

DECLARE @i int
DECLARE	@s	varchar(2)

select "ALTER TABLE " + object_name(frk.tableid) + " DROP CONSTRAINT " + object_name(frk.constrid) from sysreferences frk


create table #clees_etrangeres
(
	nom_table	varchar(30) null,
	contrainte	varchar(30) null,
	reference	varchar(30) null,
	tableid		int null,
	constrid	int null,
	reftabid	int null,
	fokey1		smallint null,
	nom_ctcol1	varchar(30) null,
	fokey2		smallint null,
	nom_ctcol2	varchar(30) null,
	fokey3		smallint null,
	nom_ctcol3	varchar(30) null,
	fokey4		smallint null,
	nom_ctcol4	varchar(30) null,
	fokey5		smallint null,
	nom_ctcol5	varchar(30) null,
	fokey6		smallint null,
	nom_ctcol6	varchar(30) null,
	fokey7		smallint null,
	nom_ctcol7	varchar(30) null,
	fokey8		smallint null,
	nom_ctcol8	varchar(30) null,
	fokey9		smallint null,
	nom_ctcol9	varchar(30) null,
	fokey10		smallint null,
	nom_ctcol10	varchar(30) null,
	fokey11		smallint null,
	nom_ctcol11	varchar(30) null,
	fokey12		smallint null,
	nom_ctcol12	varchar(30) null,
	fokey13		smallint null,
	nom_ctcol13	varchar(30) null,
	fokey14		smallint null,
	nom_ctcol14	varchar(30) null,
	fokey15		smallint null,
	nom_ctcol15	varchar(30) null,
	fokey16		smallint null,
	nom_ctcol16	varchar(30) null,
	refkey1		smallint null,
	nom_rfcol1	varchar(30) null,
	refkey2		smallint null,
	nom_rfcol2	varchar(30) null,
	refkey3		smallint null,
	nom_rfcol3	varchar(30) null,
	refkey4		smallint null,
	nom_rfcol4	varchar(30) null,
	refkey5		smallint null,
	nom_rfcol5	varchar(30) null,
	refkey6		smallint null,
	nom_rfcol6	varchar(30) null,
	refkey7		smallint null,
	nom_rfcol7	varchar(30) null,
	refkey8		smallint null,
	nom_rfcol8	varchar(30) null,
	refkey9		smallint null,
	nom_rfcol9	varchar(30) null,
	refkey10	smallint null,
	nom_rfcol10	varchar(30) null,
	refkey11	smallint null,
	nom_rfcol11	varchar(30) null,
	refkey12	smallint null,
	nom_rfcol12	varchar(30) null,
	refkey13	smallint null,
	nom_rfcol13	varchar(30) null,
	refkey14	smallint null,
	nom_rfcol14	varchar(30) null,
	refkey15	smallint null,
	nom_rfcol15	varchar(30) null,
	refkey16	smallint null,
	nom_rfcol16	varchar(30) null
)


insert 	into #clees_etrangeres
(
	nom_table,
	contrainte,
	reference,
	tableid,
	constrid,
	reftabid,
	fokey1,
	fokey2,
	fokey3,
	fokey4,
	fokey5,
	fokey6,
	fokey7,
	fokey8,
	fokey9,
	fokey10,
	fokey11,
	fokey12,
	fokey13,
	fokey14,
	fokey15,
	fokey16,
	refkey1,
	refkey2,
	refkey3,
	refkey4,
	refkey5,
	refkey6,
	refkey7,
	refkey8,
	refkey9,
	refkey10,
	refkey11,
	refkey12,
	refkey13,
	refkey14,
	refkey15,
	refkey16
)
select	object_name(frk.tableid),
		object_name(frk.constrid),
		object_name(frk.reftabid),
		tableid,
		constrid,    
		reftabid,
		frk.fokey1 ,
		frk.fokey2 ,
		frk.fokey3 ,
		frk.fokey4 ,
		frk.fokey5 ,
		frk.fokey6 ,
		frk.fokey7 ,
		frk.fokey8 ,
		frk.fokey9 ,
		frk.fokey10 ,
		frk.fokey11 ,
		frk.fokey12 ,
		frk.fokey13 ,
		frk.fokey14 ,
		frk.fokey15 ,
		frk.fokey16 ,
		frk.refkey1 ,
		frk.refkey2 ,
		frk.refkey3 ,
		frk.refkey4 ,
		frk.refkey5 ,
		frk.refkey6 ,
		frk.refkey7 ,
		frk.refkey8 ,
		frk.refkey9 ,
		frk.refkey10 ,
		frk.refkey11 ,
		frk.refkey12 ,
		frk.refkey13 ,
		frk.refkey14 ,
		frk.refkey15 ,
		frk.refkey16 
from 	sysreferences frk




SET @i=1


WHILE (@i <= 16) BEGIN
	SET @s = (select(convert(varchar(2), @i )))
	
	exec ("
		update	#clees_etrangeres
		set		nom_ctcol" + @s + "= col.name
		from	sysobjects as tab,
				syscolumns as col
		where 	tab.id = col.id
		  and	tab.id = tableid
		  and	fokey" + @s + "= col.colid
		")
	select @i = (select @i + 1)
END

SET @i=1

WHILE (@i <= 16) BEGIN
	SET @s = (select(convert(varchar(2), @i )))
	
	exec ("
		update	#clees_etrangeres
		set		nom_rfcol" + @s + "= col.name
		from	sysobjects as tab,
				syscolumns as col
		where 	tab.id = col.id
		  and	tab.id = tableid
		  and	refkey" + @s + "= col.colid
		")
	select @i = (select @i + 1)
END


select 	" ALTER TABLE " +
		nom_table+ 	
		" ADD CONSTRAINT "+
		contrainte +
		" FOREIGN KEY ("  +
		nom_ctcol1,
		CASE WHEN (nom_ctcol2 <> "") THEN "," + nom_ctcol2 ELSE "" END
		+
		CASE WHEN (nom_ctcol3 <> "") THEN "," + nom_ctcol3 ELSE "" END
		+
		CASE WHEN (nom_ctcol4 <> "") THEN "," + nom_ctcol4 ELSE "" END
		+
		CASE WHEN (nom_ctcol5 <> "") THEN "," + nom_ctcol5 ELSE "" END
		+
		CASE WHEN (nom_ctcol6 <> "") THEN "," + nom_ctcol6 ELSE "" END
		+
		CASE WHEN (nom_ctcol7 <> "") THEN "," + nom_ctcol7 ELSE "" END
		+
		CASE WHEN (nom_ctcol8 <> "") THEN "," + nom_ctcol8 ELSE "" END
		+
		CASE WHEN (nom_ctcol9 <> "") THEN "," + nom_ctcol9 ELSE "" END
		+
		CASE WHEN (nom_ctcol10 <> "") THEN "," + nom_ctcol10 ELSE "" END
		+
		CASE WHEN (nom_ctcol11 <> "") THEN "," + nom_ctcol11 ELSE "" END
		+
		CASE WHEN (nom_ctcol12 <> "") THEN "," + nom_ctcol12 ELSE "" END
		+
		CASE WHEN (nom_ctcol13 <> "") THEN "," + nom_ctcol13 ELSE "" END
		+
		CASE WHEN (nom_ctcol14 <> "") THEN "," + nom_ctcol14 ELSE "" END
		+
		CASE WHEN (nom_ctcol15 <> "") THEN "," + nom_ctcol15 ELSE "" END
		+
		CASE WHEN (nom_ctcol16 <> "") THEN "," + nom_ctcol16 ELSE "" END
		+
		") REFERENCES "
		+
		reference
		+
		"("
		+
		nom_rfcol1
		+
		CASE WHEN (nom_rfcol2 <> "") THEN "," + nom_rfcol2 ELSE "" END
		+
		CASE WHEN (nom_rfcol3 <> "") THEN "," + nom_rfcol3 ELSE "" END
		+
		CASE WHEN (nom_rfcol4 <> "") THEN "," + nom_rfcol4 ELSE "" END
		+
		CASE WHEN (nom_rfcol5 <> "") THEN "," + nom_rfcol5 ELSE "" END
		+
		CASE WHEN (nom_rfcol6 <> "") THEN "," + nom_rfcol6 ELSE "" END
		+
		CASE WHEN (nom_rfcol7 <> "") THEN "," + nom_rfcol7 ELSE "" END
		+
		CASE WHEN (nom_rfcol8 <> "") THEN "," + nom_rfcol8 ELSE "" END
		+
		CASE WHEN (nom_rfcol9 <> "") THEN "," + nom_rfcol9 ELSE "" END
		+
		CASE WHEN (nom_rfcol10 <> "") THEN "," + nom_rfcol10 ELSE "" END
		+
		CASE WHEN (nom_rfcol11 <> "") THEN "," + nom_rfcol11 ELSE "" END
		+
		CASE WHEN (nom_rfcol12 <> "") THEN "," + nom_rfcol12 ELSE "" END
		+
		CASE WHEN (nom_rfcol13 <> "") THEN "," + nom_rfcol13 ELSE "" END
		+
		CASE WHEN (nom_rfcol14 <> "") THEN "," + nom_rfcol14 ELSE "" END
		+
		CASE WHEN (nom_rfcol15 <> "") THEN "," + nom_rfcol15 ELSE "" END
		+
		CASE WHEN (nom_rfcol16 <> "") THEN "," + nom_rfcol16 ELSE "" END
		+ 
		")"
from #clees_etrangeres

drop table  #clees_etrangeres

END

IF OBJECT_ID('dbo.PS_FOREIGN_KEYS') IS NOT NULL
    PRINT '<<< CREATED PROCEDURE dbo.PS_FOREIGN_KEYS >>>'
ELSE
    PRINT '<<< FAILED CREATING PROCEDURE dbo.PS_FOREIGN_KEYS >>>'
go
